HDU 2389 Rain on your Parade(Hopcroft-Carp算法板子题)

来源:互联网 发布:网络购彩票 编辑:程序博客网 时间:2024/06/04 07:53

Description

You’re giving a party in the garden of your villa by the sea. The party is a huge success, and everyone is here. It’s a warm, sunny evening, and a soothing wind sends fresh, salty air from the sea. The evening is progressing just as you had imagined. It could be the perfect end of a beautiful day.
But nothing ever is perfect. One of your guests works in weather forecasting. He suddenly yells, “I know that breeze! It means its going to rain heavily in just a few minutes!” Your guests all wear their best dresses and really would not like to get wet, hence they stand terrified when hearing the bad news.
You have prepared a few umbrellas which can protect a few of your guests. The umbrellas are small, and since your guests are all slightly snobbish, no guest will share an umbrella with other guests. The umbrellas are spread across your (gigantic) garden, just like your guests. To complicate matters even more, some of your guests can’t run as fast as the others.
Can you help your guests so that as many as possible find an umbrella before it starts to pour?

Given the positions and speeds of all your guests, the positions of the umbrellas, and the time until it starts to rain, find out how many of your guests can at most reach an umbrella. Two guests do not want to share an umbrella, however.

Input

The input starts with a line containing a single integer, the number of test cases.
Each test case starts with a line containing the time t in minutes until it will start to rain (1 <=t <= 5). The next line contains the number of guests m (1 <= m <= 3000), followed by m lines containing x- and y-coordinates as well as the speed si in units per minute (1 <= s i <= 3000) of the guest as integers, separated by spaces. After the guests, a single line contains n (1 <= n <= 3000), the number of umbrellas, followed by n lines containing the integer coordinates of each umbrella, separated by a space.
The absolute value of all coordinates is less than 10000.

Output

For each test case, write a line containing “Scenario #i:”, where i is the number of the test case starting at 1. Then, write a single line that contains the number of guests that can at most reach an umbrella before it starts to rain. Terminate every test case with a blank line.

Sample Input

2
1
2
1 0 3
3 0 3
2
4 0
6 0
1
2
1 1 2
3 3 2
2
2 2
4 4

Sample Output

Scenario #1:
2

Scenario #2:
2



题意:有n个人m把伞,在t秒后要下雨,给出每个人和伞的坐标和每个人走路的速度,问你在t秒内最多能有几个人能拿

到伞(每把伞只能一个人用)。n,m<=3000。


匈牙利算法的时间复杂度是O(n*E),这题的边的数量达到了3000*3000,所以用匈牙利肯定会T,Hopcroft-Carp的时间

复杂度是O(sqrt(n)*E).

建图就是暴力枚举 每个人能拿到哪些伞,能拿到的就建边~

#include<iostream>  #include<cstdio>  #include<queue>  #include<cstring>  #include<vector>  using namespace std;  /* *******************************  * 二分图匹配(Hopcroft-Carp算法)  * 复杂度O(sqrt(n)*E)  * 邻接表存图,vector实现  * vector先初始化,然后假如边  * uN 为左端的顶点数,使用前赋值(点编号1开始)  */  const int maxn = 3e3+5;  const int INF = 0x3f3f3f3f;  vector<int> g[maxn];  int uN;  int Mx[maxn], My[maxn];  int dx[maxn], dy[maxn];  int dis;  bool vis[maxn];    bool searchP()  {      queue<int> q;      dis = INF;      memset(dx, -1, sizeof(dx));      memset(dy, -1, sizeof(dy));      for(int i = 1; i <= uN; i++)      {          if(Mx[i] == -1)          {              q.push(i);              dx[i] = 0;          }      }      while(!q.empty())      {          int u = q.front();          q.pop();          if(dx[u] > dis) break;          int sz = g[u].size();          for(int i = 0; i < sz; i++)          {              int v = g[u][i];              if(dy[v] == -1)              {                  dy[v] = dx[u]+1;                  if(My[v] == -1) dis = dy[v];                  else                  {                      dx[My[v]] = dy[v]+1;                      q.push(My[v]);                  }              }          }      }      return dis != INF;  }    bool dfs(int u)  {      int sz = g[u].size();      for(int i = 0; i < sz; i++)      {          int v = g[u][i];          if(!vis[v] && dy[v] == dx[u]+1)          {              vis[v] = 1;              if(My[v] != -1 && dy[v] == dis) continue;              if(My[v] == -1 || dfs(My[v]))              {                  My[v] = u;                  Mx[u] = v;                  return true;              }          }      }      return false;  }    int MaxMatch()  {      int res = 0;      memset(Mx, -1, sizeof(Mx));      memset(My, -1, sizeof(My));      while(searchP())      {          memset(vis, 0, sizeof(vis));          for(int i = 1; i <= uN; i++)              if(Mx[i] == -1 && dfs(i))                  res++;      }      return res;  }    /******************************************************/    struct Point  {      int x, y, s;      void input1()      {          scanf("%d%d%d", &x, &y, &s);      }      void input2()      {          scanf("%d%d", &x, &y);      }  };    Point p1[maxn], p2[maxn];    int dis2(Point a, Point b)  {      return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);  }    int main(void)  {      int T, t, ca = 1, n, m;      cin >> T;      while(T--)      {          for(int i = 0; i < maxn; i++)              g[i].clear();          scanf("%d%d", &t, &n);          for(int i = 1; i <= n; i++)              p1[i].input1();          scanf("%d", &m);          for(int i = 1; i <= m; i++)              p2[i].input2();          uN = n;          for(int i = 1; i <= n; i++)              for(int j = 1; j <= m; j++)                  if(dis2(p1[i], p2[j]) <= p1[i].s*p1[i].s*t*t)                      g[i].push_back(j);          printf("Scenario #%d:\n%d\n\n", ca++, MaxMatch());      }      return 0;  }  


阅读全文
0 0
原创粉丝点击